// MachDevImplementatio.h : "UniversalBlank"
#pragma once

#ifndef __AFXWIN_H__
#error include 'stdafx.h' before including this file for PCH
#endif

typedef void (CALLBACK *NoParms) ();
typedef void (_cdecl *OneShort) ( short );
typedef double (_cdecl *DoubleShort) ( short );
typedef void (_cdecl *DoubleShortDouble) ( short , double );
typedef bool (_cdecl *BoolShort) ( short );
typedef void (_cdecl *VoidShortBool) ( short, bool );
typedef void (_cdecl *CSTRret) ( CString );
typedef void (_cdecl *VoidLPCSTR) (LPCTSTR );

CString	myProfileInit (CString name, CXMLProfile *DevProf);	// initial acces to Mach profile
															// when enumerating available plugins
void	myInitControl (CXMLProfile *DevProf);									// called during Mach initialisation
															// you can influence subsequent init by actions here
															// **** Not used in typical device plugin
void	myPostInitControl (CXMLProfile *DevProf);								// called when mach fully set up
void	myConfig (CXMLProfile *DevProf);					// Called to configure the device
void	myUpdate ();										// 10Hz update loop
void	myHighSpeedUpdate ();								// called at 40Hz
void    myCleanUp();                                        //Used to cleanup heap variables before destrucion of PlugIn
void    myHome( short axis);								//homing calls from Mach3.
void    myProbe();											//probing calls from Mach3.                                          
void    myNotify( int ID );									//info from Mach using VB "NotifyPlugin(# value)"

extern TrajectoryControl *MainPlanner;	// used for most planner funcitons and program control 
extern CMach4View *MachView;			// used for most framework and configuration calls. 
extern TrajBuffer *Engine;				// Ring0 memory for printer port control and other device syncronisation
extern setup *_setup;					// Trajectory planners setup block. Always in effect

extern OneShort           DoButton;     // void DoButton( code )
extern DoubleShort        GetDRO;       // Double GetDRO( code )
extern DoubleShortDouble  SetDRO;       // void   SetDRO( short code, double value);
extern BoolShort          GetLED;       // bool   GetLED( short code );
extern VoidShortBool      SetLED;       // void   SetLED( short code, bool);
extern CSTRret            GetProName;   // CString GetProName()
extern VoidLPCSTR         Code;         // void    Code( "G0X10Y10" );



