// MachDevImplementation.cpp  "UniversalBlank"

#include "stdafx.h"
#include "resource.h"
#include "TrajectoryControl.h"
#include "Mach4View.h"
#include "Engine.h"
#include "rs274ngc.h"
#include "XMLProfile.h"
#include "MachDevice.h"
#include "MachDevImplementation.h"
#include <mmsystem.h>
#include <math.h>
//#include "ExternalMovement.h" //If using an External Motion control device
//#include "UDPSocket.h"  //If needing Ethernet Connection

#include "MyPlugin_Dlg.h"  //****The header file for the Dialog for this plugin***

extern TrajectoryControl *MainPlanner; //used for most planner funcitons and program control 
extern CMach4View *MachView;  //used for most framework and configuration calls. 
extern TrajBuffer *Engine;     //Ring0 memory for printer port control and other device syncronisation
extern setup *_setup;          //Trajectory planners setup block. Always in effect
extern CXMLProfile *DevProf;
extern void myNotify( int ID );
extern IntShort   GetMenuRange;


// =======================================================================================
//
// My variables 
//
// =====================Local VARS========================================================
//bool LED1412; LED varible to control from myNotify
//bool Spin;

//======================================================================================
//
//                          End My Vars
//
//======================================================================================

void myCleanUp() //used for destrcution of variables prior to exit..  Called as MAch3 shuts down. 
{
	
}

CString	myProfileInit (CString name, CXMLProfile *DevProf)	
{
	//m_MyVar = DevProf->GetProfileInt("MyPlugin_Dlg", "MyVar", 0 ); //"0" is a default return value
		
	return "My Plugin - Scott Shafer v1.0";
} // myProfileInit

void	myInitControl ()
{   
	return;
} //myInitControl

void	myPostInitControl ()
{		     
	return;	
} //myPostInitControl

void	myNotify ( int ID)

{
	//if( ID == EX_SPINOFF ) //notifications from mach
	//{
		//Spin = 0;
	//}

	//if( ID == EX_SPINON ) //Notifications from mach
	//{
		//Spin = 1;
	//}

	//if( ID == 200 ) //NotifyPlugins(200) sent from Mach VB
	//{
		//LED1412 = 1;
	//}
	
	//if( ID == 201 ) //NotifyPlugins(201) sent from Mach VB
	//{
		//LED1412 = 0;
	//}
	 

} //myNotify 

void	myConfig (CXMLProfile *DevProf)
{
	//DevProf->WriteProfileInt("MyPlugin_Dlg","MyVar",m_MyVar); //Writes to XML: MyPlugin_Dlg>MyVar>m_MyVar	
	 	
	MyPlugin_Dlg dlg; //(Instantiates the Class "MyPlugin_Dlg" from the class made of the Dialog window)
	
	//dlg.m_MyVar = m_MyVar; //(gets the var from the profile, puts it in the box)	
	
	if (dlg.DoModal() == IDOK) //if the OK button is pushed on the dialog, it updates the new values to the vars.
	{
	//m_MyVar = dlg.m_MyVar; //(takes the dialog value and puts it in the Var)	
	
	}
} // myConfig

//=========================================================================================================
//


void   myHome( short axis)
{
  //Called to add a homing axis.. "axis" is the one to add to current homing if applicable..  
}

void  myProbe()
{
  //OK, we have a probe command. So we need to activate the Halt mask, check to see its on, then do the move..  
}

void myPurge( short flags)
{    
	//sent to zero an axis or reset hardware to 0,0,0 or empty messages depending on the flag.    
}


//===========================================MY UPDATE!!!!!!!!!!==========================================

void	myUpdate () // 10Hz update loop
{//====================START myupdate================================

	if(Spin)
	{
		SetLED(1400,1);
	}
	else
	{
		SetLED(1400,0);
	}

		//if(LED1412) //varible to control from myNotify
		//{
		//SetLED(1412,1);
		//}
		//else
		//{
		//SetLED(1412,1);
		//}

//================for external motion device
//GetInputs();
//SetOutputs();
//SendHoldingMovement();
//HandleSequences();
//============================================
	
}//=========================END myupdate end================================

	
void	myHighSpeedUpdate ()
{
} // myHighSpeed Update